<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>SpaceFighter2020: src/Weapon.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">SpaceFighter2020
   </div>
   <div id="projectbrief">This documentation reffers to the game Space Fighter 2020 created for pa2 course. Game is side-scrolling shooter where the goal is to get on the end of the level and kill as much as enemy ships as possible. Player can pick up bonuses for repairing point of health or upgrading his weapons.</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">Weapon.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="Weapon_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#ifndef Weapon_H</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#define Weapon_H</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#include &lt;chrono&gt;</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160; </div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160; </div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="keyword">class </span><a class="code" href="classGameScene.html">GameScene</a>;</div>
<div class="line"><a name="l00012"></a><span class="lineno"><a class="line" href="classWeapon.html">   12</a></span>&#160;<span class="keyword">class </span><a class="code" href="classWeapon.html">Weapon</a>{</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;    <a class="code" href="classWeapon.html#a142fe6fb7afc031f9593e085e2478b6d">Weapon</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> &amp;x, <span class="keyword">const</span> <span class="keywordtype">int</span> &amp;y);</div>
<div class="line"><a name="l00019"></a><span class="lineno"><a class="line" href="classWeapon.html#ac5f7305f5d08c48003c826e6e73f37da">   19</a></span>&#160;    <span class="keyword">virtual</span> <a class="code" href="classWeapon.html#ac5f7305f5d08c48003c826e6e73f37da">~Weapon</a>(){}</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classWeapon.html#a1f1b8ec10376846551d7731ca7ea0bfa">SetLevel</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> &amp; level);</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classWeapon.html#a0b599385c909713ad4d3f1ab86757cab">Upgrade</a>();</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classWeapon.html#a6cbe744adaae3a57d813c39fe9802bd1">SetFireRate</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> &amp; rate);</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classWeapon.html#ac18084196a571d8ec73321dce03ae6eb">SetDirection</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> &amp; dirx);</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classWeapon.html#aa80c770361cc840b283afc903d3b6bb1">SetOffsetXY</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> &amp; x, <span class="keyword">const</span> <span class="keywordtype">int</span> &amp; y);</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160; </div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">int</span> <a class="code" href="classWeapon.html#a378548bc64e0e44f664c6634b14d0e82">GetType</a>()<span class="keyword">const</span> = 0;</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    <span class="keywordtype">int</span> <a class="code" href="classWeapon.html#a9f71a08f964d57ed0c2ff0a0da3f5221">GetLevel</a>()<span class="keyword">const</span>;</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160; </div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classWeapon.html#ae1143ac517648fed1df454cf59bdc13f">Update</a>();</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    </div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classWeapon.html#a8502c88be7164dca0a53b5d7aec871c9">Fire</a>() =0; </div>
<div class="line"><a name="l00064"></a><span class="lineno"><a class="line" href="classWeapon.html#ac397ebc3e719835687b7c4a84ac07c21">   64</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="classWeapon.html#ac397ebc3e719835687b7c4a84ac07c21">m_FireRate</a>; </div>
<div class="line"><a name="l00065"></a><span class="lineno"><a class="line" href="classWeapon.html#a7058beed78f19ccf108c4363e3080345">   65</a></span>&#160;    std::chrono::time_point&lt;std::chrono::system_clock&gt; <a class="code" href="classWeapon.html#a7058beed78f19ccf108c4363e3080345">m_CoolDownTime</a>; </div>
<div class="line"><a name="l00066"></a><span class="lineno"><a class="line" href="classWeapon.html#aceb36b89ece7aab9686966507b23dc5a">   66</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="classWeapon.html#aceb36b89ece7aab9686966507b23dc5a">m_Level</a>;</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    </div>
<div class="line"><a name="l00068"></a><span class="lineno"><a class="line" href="classWeapon.html#adbe629cb34e96f7bde59686f6706835e">   68</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="classWeapon.html#adbe629cb34e96f7bde59686f6706835e">m_FireDirX</a>;</div>
<div class="line"><a name="l00069"></a><span class="lineno"><a class="line" href="classWeapon.html#abf73b56151eb77d72af2278304fb0c73">   69</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="classWeapon.html#abf73b56151eb77d72af2278304fb0c73">m_OffsetX</a>;</div>
<div class="line"><a name="l00070"></a><span class="lineno"><a class="line" href="classWeapon.html#a619c784b69a7d6bb06667752bd0fea1f">   70</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="classWeapon.html#a619c784b69a7d6bb06667752bd0fea1f">m_OffsetY</a>;</div>
<div class="line"><a name="l00071"></a><span class="lineno"><a class="line" href="classWeapon.html#a4e43f2b40941651214aef613a4b0cca4">   71</a></span>&#160;    <span class="keyword">const</span> <span class="keywordtype">int</span> &amp;<a class="code" href="classWeapon.html#a4e43f2b40941651214aef613a4b0cca4">m_X</a>; </div>
<div class="line"><a name="l00072"></a><span class="lineno"><a class="line" href="classWeapon.html#a891a9fdae2458e7593ad15661e8fa500">   72</a></span>&#160;    <span class="keyword">const</span> <span class="keywordtype">int</span> &amp;<a class="code" href="classWeapon.html#a891a9fdae2458e7593ad15661e8fa500">m_Y</a>; </div>
<div class="line"><a name="l00073"></a><span class="lineno"><a class="line" href="classWeapon.html#a892a4b8e8c359185a59bd184c2d2f728">   73</a></span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classWeapon.html#a892a4b8e8c359185a59bd184c2d2f728">m_Type</a>;</div>
<div class="line"><a name="l00074"></a><span class="lineno"><a class="line" href="classWeapon.html#a0c0736882e2a4ebc77755f57d70f1ed7">   74</a></span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classWeapon.html#a0c0736882e2a4ebc77755f57d70f1ed7">m_StateSwitch</a>; </div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;};</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160; </div>
<div class="line"><a name="l00081"></a><span class="lineno"><a class="line" href="classRocketLauncher.html">   81</a></span>&#160;<span class="keyword">class </span><a class="code" href="classRocketLauncher.html">RocketLauncher</a> : <span class="keyword">public</span> <a class="code" href="classWeapon.html">Weapon</a>{</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;    <a class="code" href="classRocketLauncher.html#a2d86b3d05cee3bfe00c911aee23106b4">RocketLauncher</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> &amp;x, <span class="keyword">const</span> <span class="keywordtype">int</span> &amp;y);</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;    <span class="keywordtype">int</span> <a class="code" href="classRocketLauncher.html#a8366a645e8c4896d575db1d814e2cdd6">GetType</a>()<span class="keyword">const override</span>;</div>
<div class="line"><a name="l00089"></a><span class="lineno"><a class="line" href="classRocketLauncher.html#a2766034d0e2f7290213795b2bc60e48c">   89</a></span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classRocketLauncher.html#a2766034d0e2f7290213795b2bc60e48c">m_Type</a> = 0;</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classRocketLauncher.html#a56b09854e1a553f72aed93663ab9cefa">Fire</a>()<span class="keyword">override</span>;</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    </div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;};</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160; </div>
<div class="line"><a name="l00099"></a><span class="lineno"><a class="line" href="classMachineGun.html">   99</a></span>&#160;<span class="keyword">class </span><a class="code" href="classMachineGun.html">MachineGun</a> : <span class="keyword">public</span> <a class="code" href="classWeapon.html">Weapon</a>{</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;    <a class="code" href="classMachineGun.html#ac3db7af0c8523347c0ba1cc834a9c4d7">MachineGun</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> &amp;x, <span class="keyword">const</span> <span class="keywordtype">int</span> &amp;y);</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;    <span class="keywordtype">int</span> <a class="code" href="classMachineGun.html#a41cc778a2ea85547abfc274a5de5e475">GetType</a>()<span class="keyword">const override</span>;</div>
<div class="line"><a name="l00108"></a><span class="lineno"><a class="line" href="classMachineGun.html#a4757876896ca2b84539caca2ff1bdf78">  108</a></span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classMachineGun.html#a4757876896ca2b84539caca2ff1bdf78">m_Type</a> = 1;</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classMachineGun.html#a8ac70092ebc2d0b648d9016a0a37206e">Fire</a>()<span class="keyword">override</span>;</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;};</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160; </div>
<div class="line"><a name="l00117"></a><span class="lineno"><a class="line" href="classCannon.html">  117</a></span>&#160;<span class="keyword">class </span><a class="code" href="classCannon.html">Cannon</a> : <span class="keyword">public</span> <a class="code" href="classWeapon.html">Weapon</a>{</div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;    <a class="code" href="classCannon.html#ad9e206040466b4ef6fdfc48bc1615aea">Cannon</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> &amp;x, <span class="keyword">const</span> <span class="keywordtype">int</span> &amp;y);</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;    <span class="keywordtype">int</span> <a class="code" href="classCannon.html#a1e623adcdd54a92c85f526c3c8735a43">GetType</a>()<span class="keyword">const override</span>;</div>
<div class="line"><a name="l00125"></a><span class="lineno"><a class="line" href="classCannon.html#a83a298d8019650b0a029a5139e0fe92f">  125</a></span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classCannon.html#a83a298d8019650b0a029a5139e0fe92f">m_Type</a> = 2;</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classCannon.html#a96b9dcbbc69d34a1216731d753374202">Fire</a>()<span class="keyword">override</span>;</div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;};</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160; </div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* Weapon_H */</span><span class="preprocessor"></span></div>
</div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="aclassWeapon_html"><div class="ttname"><a href="classWeapon.html">Weapon</a></div><div class="ttdoc">Factory styled class for creating projectiles.</div><div class="ttdef"><b>Definition:</b> Weapon.h:12</div></div>
<div class="ttc" id="aclassWeapon_html_ac18084196a571d8ec73321dce03ae6eb"><div class="ttname"><a href="classWeapon.html#ac18084196a571d8ec73321dce03ae6eb">Weapon::SetDirection</a></div><div class="ttdeci">void SetDirection(const int &amp;dirx)</div><div class="ttdoc">Set horizontal movement direction.</div><div class="ttdef"><b>Definition:</b> Weapon.cpp:26</div></div>
<div class="ttc" id="aclassWeapon_html_adbe629cb34e96f7bde59686f6706835e"><div class="ttname"><a href="classWeapon.html#adbe629cb34e96f7bde59686f6706835e">Weapon::m_FireDirX</a></div><div class="ttdeci">int m_FireDirX</div><div class="ttdef"><b>Definition:</b> Weapon.h:68</div></div>
<div class="ttc" id="aclassWeapon_html_a142fe6fb7afc031f9593e085e2478b6d"><div class="ttname"><a href="classWeapon.html#a142fe6fb7afc031f9593e085e2478b6d">Weapon::Weapon</a></div><div class="ttdeci">Weapon(const int &amp;x, const int &amp;y)</div><div class="ttdoc">Construct a new Weapon object with coordinate refferences to owner of weapon.</div><div class="ttdef"><b>Definition:</b> Weapon.cpp:6</div></div>
<div class="ttc" id="aclassRocketLauncher_html_a8366a645e8c4896d575db1d814e2cdd6"><div class="ttname"><a href="classRocketLauncher.html#a8366a645e8c4896d575db1d814e2cdd6">RocketLauncher::GetType</a></div><div class="ttdeci">int GetType() const override</div><div class="ttdef"><b>Definition:</b> Weapon.cpp:53</div></div>
<div class="ttc" id="aclassWeapon_html_a378548bc64e0e44f664c6634b14d0e82"><div class="ttname"><a href="classWeapon.html#a378548bc64e0e44f664c6634b14d0e82">Weapon::GetType</a></div><div class="ttdeci">virtual int GetType() const =0</div></div>
<div class="ttc" id="aclassCannon_html"><div class="ttname"><a href="classCannon.html">Cannon</a></div><div class="ttdoc">Cannon slow firing high damage weapon.</div><div class="ttdef"><b>Definition:</b> Weapon.h:117</div></div>
<div class="ttc" id="aclassWeapon_html_ae1143ac517648fed1df454cf59bdc13f"><div class="ttname"><a href="classWeapon.html#ae1143ac517648fed1df454cf59bdc13f">Weapon::Update</a></div><div class="ttdeci">void Update()</div><div class="ttdoc">Fires projectile after cooldown has run out.</div><div class="ttdef"><b>Definition:</b> Weapon.cpp:39</div></div>
<div class="ttc" id="aclassWeapon_html_aceb36b89ece7aab9686966507b23dc5a"><div class="ttname"><a href="classWeapon.html#aceb36b89ece7aab9686966507b23dc5a">Weapon::m_Level</a></div><div class="ttdeci">int m_Level</div><div class="ttdef"><b>Definition:</b> Weapon.h:66</div></div>
<div class="ttc" id="aclassRocketLauncher_html_a2766034d0e2f7290213795b2bc60e48c"><div class="ttname"><a href="classRocketLauncher.html#a2766034d0e2f7290213795b2bc60e48c">RocketLauncher::m_Type</a></div><div class="ttdeci">static const int m_Type</div><div class="ttdef"><b>Definition:</b> Weapon.h:89</div></div>
<div class="ttc" id="aclassMachineGun_html_a4757876896ca2b84539caca2ff1bdf78"><div class="ttname"><a href="classMachineGun.html#a4757876896ca2b84539caca2ff1bdf78">MachineGun::m_Type</a></div><div class="ttdeci">static const int m_Type</div><div class="ttdef"><b>Definition:</b> Weapon.h:108</div></div>
<div class="ttc" id="aclassWeapon_html_ac397ebc3e719835687b7c4a84ac07c21"><div class="ttname"><a href="classWeapon.html#ac397ebc3e719835687b7c4a84ac07c21">Weapon::m_FireRate</a></div><div class="ttdeci">int m_FireRate</div><div class="ttdef"><b>Definition:</b> Weapon.h:64</div></div>
<div class="ttc" id="aclassWeapon_html_a1f1b8ec10376846551d7731ca7ea0bfa"><div class="ttname"><a href="classWeapon.html#a1f1b8ec10376846551d7731ca7ea0bfa">Weapon::SetLevel</a></div><div class="ttdeci">void SetLevel(const int &amp;level)</div><div class="ttdoc">Set the Level of a weapon.</div><div class="ttdef"><b>Definition:</b> Weapon.cpp:12</div></div>
<div class="ttc" id="aclassWeapon_html_abf73b56151eb77d72af2278304fb0c73"><div class="ttname"><a href="classWeapon.html#abf73b56151eb77d72af2278304fb0c73">Weapon::m_OffsetX</a></div><div class="ttdeci">int m_OffsetX</div><div class="ttdef"><b>Definition:</b> Weapon.h:69</div></div>
<div class="ttc" id="aclassCannon_html_a83a298d8019650b0a029a5139e0fe92f"><div class="ttname"><a href="classCannon.html#a83a298d8019650b0a029a5139e0fe92f">Cannon::m_Type</a></div><div class="ttdeci">static const int m_Type</div><div class="ttdef"><b>Definition:</b> Weapon.h:125</div></div>
<div class="ttc" id="aclassCannon_html_a96b9dcbbc69d34a1216731d753374202"><div class="ttname"><a href="classCannon.html#a96b9dcbbc69d34a1216731d753374202">Cannon::Fire</a></div><div class="ttdeci">void Fire() override</div><div class="ttdoc">Pure virtual function to create projectiles.</div><div class="ttdef"><b>Definition:</b> Weapon.cpp:121</div></div>
<div class="ttc" id="aclassWeapon_html_a9f71a08f964d57ed0c2ff0a0da3f5221"><div class="ttname"><a href="classWeapon.html#a9f71a08f964d57ed0c2ff0a0da3f5221">Weapon::GetLevel</a></div><div class="ttdeci">int GetLevel() const</div><div class="ttdef"><b>Definition:</b> Weapon.cpp:36</div></div>
<div class="ttc" id="aclassMachineGun_html_ac3db7af0c8523347c0ba1cc834a9c4d7"><div class="ttname"><a href="classMachineGun.html#ac3db7af0c8523347c0ba1cc834a9c4d7">MachineGun::MachineGun</a></div><div class="ttdeci">MachineGun(const int &amp;x, const int &amp;y)</div><div class="ttdoc">Construct a new Machine Gun object with coordinate refferences to owner of weapon.</div><div class="ttdef"><b>Definition:</b> Weapon.cpp:81</div></div>
<div class="ttc" id="aclassWeapon_html_a891a9fdae2458e7593ad15661e8fa500"><div class="ttname"><a href="classWeapon.html#a891a9fdae2458e7593ad15661e8fa500">Weapon::m_Y</a></div><div class="ttdeci">const int &amp; m_Y</div><div class="ttdef"><b>Definition:</b> Weapon.h:72</div></div>
<div class="ttc" id="aclassRocketLauncher_html"><div class="ttname"><a href="classRocketLauncher.html">RocketLauncher</a></div><div class="ttdoc">RocketLauncher balanced weapon with direct fire.</div><div class="ttdef"><b>Definition:</b> Weapon.h:81</div></div>
<div class="ttc" id="aclassWeapon_html_ac5f7305f5d08c48003c826e6e73f37da"><div class="ttname"><a href="classWeapon.html#ac5f7305f5d08c48003c826e6e73f37da">Weapon::~Weapon</a></div><div class="ttdeci">virtual ~Weapon()</div><div class="ttdef"><b>Definition:</b> Weapon.h:19</div></div>
<div class="ttc" id="aclassWeapon_html_a8502c88be7164dca0a53b5d7aec871c9"><div class="ttname"><a href="classWeapon.html#a8502c88be7164dca0a53b5d7aec871c9">Weapon::Fire</a></div><div class="ttdeci">virtual void Fire()=0</div><div class="ttdoc">Pure virtual function to create projectiles.</div></div>
<div class="ttc" id="aclassRocketLauncher_html_a56b09854e1a553f72aed93663ab9cefa"><div class="ttname"><a href="classRocketLauncher.html#a56b09854e1a553f72aed93663ab9cefa">RocketLauncher::Fire</a></div><div class="ttdeci">void Fire() override</div><div class="ttdoc">Pure virtual function to create projectiles.</div><div class="ttdef"><b>Definition:</b> Weapon.cpp:57</div></div>
<div class="ttc" id="aclassMachineGun_html_a41cc778a2ea85547abfc274a5de5e475"><div class="ttname"><a href="classMachineGun.html#a41cc778a2ea85547abfc274a5de5e475">MachineGun::GetType</a></div><div class="ttdeci">int GetType() const override</div><div class="ttdef"><b>Definition:</b> Weapon.cpp:85</div></div>
<div class="ttc" id="aclassWeapon_html_a0c0736882e2a4ebc77755f57d70f1ed7"><div class="ttname"><a href="classWeapon.html#a0c0736882e2a4ebc77755f57d70f1ed7">Weapon::m_StateSwitch</a></div><div class="ttdeci">bool m_StateSwitch</div><div class="ttdef"><b>Definition:</b> Weapon.h:74</div></div>
<div class="ttc" id="aclassGameScene_html"><div class="ttname"><a href="classGameScene.html">GameScene</a></div><div class="ttdoc">Mayer singlton class of GameScene, keeps track of all GameObjects. Updates GameObjects,...</div><div class="ttdef"><b>Definition:</b> GameScene.h:20</div></div>
<div class="ttc" id="aclassWeapon_html_a0b599385c909713ad4d3f1ab86757cab"><div class="ttname"><a href="classWeapon.html#a0b599385c909713ad4d3f1ab86757cab">Weapon::Upgrade</a></div><div class="ttdeci">void Upgrade()</div><div class="ttdoc">Increases weapon level by one if possible.</div><div class="ttdef"><b>Definition:</b> Weapon.cpp:16</div></div>
<div class="ttc" id="aclassCannon_html_ad9e206040466b4ef6fdfc48bc1615aea"><div class="ttname"><a href="classCannon.html#ad9e206040466b4ef6fdfc48bc1615aea">Cannon::Cannon</a></div><div class="ttdeci">Cannon(const int &amp;x, const int &amp;y)</div><div class="ttdoc">Construct a new Cannon object with coordinate refferences to owner of weapon.</div><div class="ttdef"><b>Definition:</b> Weapon.cpp:113</div></div>
<div class="ttc" id="aclassWeapon_html_a892a4b8e8c359185a59bd184c2d2f728"><div class="ttname"><a href="classWeapon.html#a892a4b8e8c359185a59bd184c2d2f728">Weapon::m_Type</a></div><div class="ttdeci">static const int m_Type</div><div class="ttdef"><b>Definition:</b> Weapon.h:73</div></div>
<div class="ttc" id="aclassMachineGun_html"><div class="ttname"><a href="classMachineGun.html">MachineGun</a></div><div class="ttdoc">MachineGun starter weapon with ability to bounce bullets off borders.</div><div class="ttdef"><b>Definition:</b> Weapon.h:99</div></div>
<div class="ttc" id="aclassWeapon_html_aa80c770361cc840b283afc903d3b6bb1"><div class="ttname"><a href="classWeapon.html#aa80c770361cc840b283afc903d3b6bb1">Weapon::SetOffsetXY</a></div><div class="ttdeci">void SetOffsetXY(const int &amp;x, const int &amp;y)</div><div class="ttdoc">Set the firing offset relative to weapon owner.</div><div class="ttdef"><b>Definition:</b> Weapon.cpp:30</div></div>
<div class="ttc" id="aclassWeapon_html_a4e43f2b40941651214aef613a4b0cca4"><div class="ttname"><a href="classWeapon.html#a4e43f2b40941651214aef613a4b0cca4">Weapon::m_X</a></div><div class="ttdeci">const int &amp; m_X</div><div class="ttdef"><b>Definition:</b> Weapon.h:71</div></div>
<div class="ttc" id="aclassWeapon_html_a619c784b69a7d6bb06667752bd0fea1f"><div class="ttname"><a href="classWeapon.html#a619c784b69a7d6bb06667752bd0fea1f">Weapon::m_OffsetY</a></div><div class="ttdeci">int m_OffsetY</div><div class="ttdef"><b>Definition:</b> Weapon.h:70</div></div>
<div class="ttc" id="aclassCannon_html_a1e623adcdd54a92c85f526c3c8735a43"><div class="ttname"><a href="classCannon.html#a1e623adcdd54a92c85f526c3c8735a43">Cannon::GetType</a></div><div class="ttdeci">int GetType() const override</div><div class="ttdef"><b>Definition:</b> Weapon.cpp:117</div></div>
<div class="ttc" id="aclassMachineGun_html_a8ac70092ebc2d0b648d9016a0a37206e"><div class="ttname"><a href="classMachineGun.html#a8ac70092ebc2d0b648d9016a0a37206e">MachineGun::Fire</a></div><div class="ttdeci">void Fire() override</div><div class="ttdoc">Pure virtual function to create projectiles.</div><div class="ttdef"><b>Definition:</b> Weapon.cpp:89</div></div>
<div class="ttc" id="aclassRocketLauncher_html_a2d86b3d05cee3bfe00c911aee23106b4"><div class="ttname"><a href="classRocketLauncher.html#a2d86b3d05cee3bfe00c911aee23106b4">RocketLauncher::RocketLauncher</a></div><div class="ttdeci">RocketLauncher(const int &amp;x, const int &amp;y)</div><div class="ttdoc">Construct a new Rocket Launcher object with coordinate refferences to owner of weapon.</div><div class="ttdef"><b>Definition:</b> Weapon.cpp:49</div></div>
<div class="ttc" id="aclassWeapon_html_a6cbe744adaae3a57d813c39fe9802bd1"><div class="ttname"><a href="classWeapon.html#a6cbe744adaae3a57d813c39fe9802bd1">Weapon::SetFireRate</a></div><div class="ttdeci">void SetFireRate(const int &amp;rate)</div><div class="ttdoc">Set the Fire Rate object.</div><div class="ttdef"><b>Definition:</b> Weapon.cpp:22</div></div>
<div class="ttc" id="aclassWeapon_html_a7058beed78f19ccf108c4363e3080345"><div class="ttname"><a href="classWeapon.html#a7058beed78f19ccf108c4363e3080345">Weapon::m_CoolDownTime</a></div><div class="ttdeci">std::chrono::time_point&lt; std::chrono::system_clock &gt; m_CoolDownTime</div><div class="ttdef"><b>Definition:</b> Weapon.h:65</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.17
</small></address>
</body>
</html>
